	.file	"bpsheap.c"
	.version	"sun386-1.0"
	.optim
.LL0:
        .data
        .comm   alreadysetupbpsandheap,4
        .comm   max_image_size,4
        .comm   oldbreakvalue,4
        .text
power:
	jmp	.L30
.L29:
/    85	  int i, p;
/    86	
/    87	  p = 1;
	movl	$1,-8(%ebp)
/    88	  for (i = 1; i <= n; ++i)
	movl	$1,-4(%ebp)
.L33:
	movl	12(%ebp),%eax
	cmpl	%eax,-4(%ebp)
	jg	.L32
/    89	    p = p * x;
	movl	-8(%ebp),%eax
	imull	8(%ebp),%eax
	movl	%eax,-8(%ebp)
.L31:
	incl	-4(%ebp)
	jmp	.L33
.L32:
/    90	  return(p);
	movl	-8(%ebp),%eax
	jmp	.L28
/    91	}
.L28:
	leave
	ret
.L30:
	pushl	%ebp
	movl	%esp,%ebp
	subl	$8,%esp
	jmp	.L29
/FUNCEND
        .data
        .text
	.globl	setupbpsandheap
setupbpsandheap:
	jmp	.L37
.L36:
/    97	  int    i, total, bpssize, heapsize, mallocsize;
/    98	  int    current_size_in_bytes, heapsize_in_bytes;
/    99	  double bpspercent, heappercent;
/   100	  char   *argp, *scanptr, *scanformat;
/   101	
/   102	  if (alreadysetupbpsandheap)   /* If this session was dumplisped ... */
	cmpl	$0,alreadysetupbpsandheap
	je	.L38
/   103	    { 
/   104	      return 0;
	movl	$0,%eax
	jmp	.L35
/   105	    }
/   106	
/   107	  total		= MINSIZE;
.L38:
	movl	$3000000,-8(%ebp)
/   108	  mallocsize	= MALLOCSIZE;
	movl	$54096,-20(%ebp)
/   109	  
/   110	  for (i=1; i<argc-1; i++)
	movl	$1,-4(%ebp)
.L41:
	movl	8(%ebp),%eax
	decl	%eax
	cmpl	%eax,-4(%ebp)
	jge	.L40
/   111	    {
/   112	      argp = argv[i];
	movl	12(%ebp),%eax
	movl	-4(%ebp),%edx
	movl	(%eax,%edx,4),%ecx
	movl	%ecx,-48(%ebp)
/   113	      if (*argp++ == '-')
	movl	-48(%ebp),%eax
	incl	-48(%ebp)
	movsbl	(%eax),%eax
	cmpl	$45,%eax
	jne	.L42
/   114	        {
/   115	          scanformat = "";
        .text
	movl	$.L43,-56(%ebp)
/   116	          switch (*argp++) {
	jmp	.L45
/   117	            case 't': scanptr = (char *)&total;
.L46:
	leal	-8(%ebp),%eax
	movl	%eax,-52(%ebp)
/   118	                      switch (*argp) {
	jmp	.L48
/   119			        case 'x': scanformat = "%x";
.L49:
        .text
	movl	$.L50,-56(%ebp)
/   120				          break;
	jmp	.L47
/   121	                        case 'd': scanformat = "%d";
.L51:
        .text
	movl	$.L52,-56(%ebp)
/   122	                                  break;
	jmp	.L47
/   123			      }
.L48:
	movl	-48(%ebp),%eax
	movsbl	(%eax),%eax
	cmpl	$100,%eax
	je	.L51
	cmpl	$120,%eax
	je	.L49
.L47:
/   124	                      break;
	jmp	.L44
/   125	            case 'm': scanptr = (char *)&mallocsize;
.L53:
	leal	-20(%ebp),%eax
	movl	%eax,-52(%ebp)
/   126	                      switch (*argp) {
	jmp	.L55
/   127	                        case 'x': scanformat = "%x";
.L56:
        .text
	movl	$.L57,-56(%ebp)
/   128	                                  break;
	jmp	.L54
/   129	                        case 'd': scanformat = "%d";
.L58:
        .text
	movl	$.L59,-56(%ebp)
/   130	                                  break;
	jmp	.L54
/   131	                      }
.L55:
	movl	-48(%ebp),%eax
	movsbl	(%eax),%eax
	cmpl	$100,%eax
	je	.L58
	cmpl	$120,%eax
	je	.L56
.L54:
/   132	                      break;
	jmp	.L44
/   133	          }
.L45:
	movl	-48(%ebp),%eax
	incl	-48(%ebp)
	movsbl	(%eax),%eax
	cmpl	$109,%eax
	je	.L53
	cmpl	$116,%eax
	je	.L46
.L44:
/   134	          if (*scanformat != 0)
	movl	-56(%ebp),%eax
	movb	(%eax),%dl
	testb	%dl,%dl
	je	.L60
/   135	            sscanf(argv[i+1],scanformat,scanptr);
	pushl	-52(%ebp)
	pushl	-56(%ebp)
	movl	12(%ebp),%eax
	movl	-4(%ebp),%edx
	incl	%edx
	pushl	(%eax,%edx,4)
	call	sscanf
	addl	$12,%esp
/   136	        }
.L60:
/   137	    }   /* end of for loop -- arg vector searched */
.L42:
.L39:
	incl	-4(%ebp)
	jmp	.L41
.L40:
/   138	
/   139	  /* insure valid values */
/   140	  if (total == 0)
	cmpl	$0,-8(%ebp)
	jne	.L62
/   141	    total = MINSIZE;
	movl	$3000000,-8(%ebp)
/   142	
/   143	  if (mallocsize <= 0)
.L62:
	cmpl	$0,-20(%ebp)
	jg	.L63
/   144	    mallocsize = MALLOCSIZE;
	movl	$54096,-20(%ebp)
/   145	
/   146	  /* Reserve some space for C's usr of io buffers, etc. By mallocing then
/   147	     freeing, the memory is sbrk'ed onto the image, but available for future
/   148	     calls to malloc, which will not need to call sbrk again. */
/   149	  free(malloc(mallocsize));	
.L63:
	pushl	-20(%ebp)
	call	malloc
	popl	%ecx
	pushl	%eax
	call	free
	popl	%ecx
/   150	
/   151	  bpssize = BPSSIZE;
	movl	$1500000,-12(%ebp)
/   152	
/   153	  heapsize_in_bytes = total - bpssize;
	movl	-8(%ebp),%eax
	subl	-12(%ebp),%eax
	movl	%eax,-28(%ebp)
/   154	
/   155	  /* On systems in which the image does not start at address 0, this won't
/   156	     really allocate the full maximum, but close enough. */
/   157	  current_size_in_bytes = (int) sbrk(0);
	pushl	$0
	call	sbrk
	popl	%ecx
	movl	%eax,-24(%ebp)
/   158	  max_image_size = power(2, _INFBITLENGTH_); /* 1 more than allowable size */
	pushl	_INFBITLENGTH_
	pushl	$2
	call	power
	addl	$8,%esp
	movl	%eax,max_image_size
/   159	  
/   160	  if ((heapsize_in_bytes + current_size_in_bytes) >= max_image_size) {
	movl	-28(%ebp),%eax
	addl	-24(%ebp),%eax
	cmpl	max_image_size,%eax
	jl	.L67
/   161	    heapsize_in_bytes = max_image_size - current_size_in_bytes;
	movl	max_image_size,%eax
	subl	-24(%ebp),%eax
	movl	%eax,-28(%ebp)
/   162	    total = heapsize_in_bytes + bpssize;
	movl	-28(%ebp),%eax
	addl	-12(%ebp),%eax
	movl	%eax,-8(%ebp)
/   163	    printf("Size requested will result in pointer values larger than\n");
        .text
	pushl	$.L69
	call	printf
	popl	%ecx
/   164	    printf(" PSL items can handle. Will allocate maximum size instead.\n\n");
        .text
	pushl	$.L70
	call	printf
	popl	%ecx
/   165	  }
/   166	
/   167	#if (NUMBEROFHEAPS == 2)
/   168	  heapsize =(heapsize_in_bytes / 4) * 2;  /* insure full words */
.L67:
	movl	-28(%ebp),%eax
	movl	$4,%ecx
	cltd
	idivl	%ecx
	leal	(%eax,%eax),%eax
	movl	%eax,-16(%ebp)
/   171	#endif
/   172	
/   173	  heappercent = ((float) (total - bpssize) / total) * 100.0;
        .data
	.align	4
.L71:
	.double	1.0000000000000000000000e+02
        .text
	movl	-8(%ebp),%eax
	subl	-12(%ebp),%eax
	movl	%eax,-64(%ebp)
       fildl   -64(%ebp)
       fidivl        -8(%ebp)
   fmull .L71
   fstpl -44(%ebp)
/   174	  bpspercent  = ((float) bpssize / total) * 100.0;
        .data
	.align	4
.L72:
	.double	1.0000000000000000000000e+02
        .text
       fildl   -12(%ebp)
       fidivl        -8(%ebp)
   fmull .L72
   fstpl -36(%ebp)
/   175	
/   176	  printf("Setting heap limit as follows:\n");
        .text
	pushl	$.L73
	call	printf
	popl	%ecx
/   177	  printf("Total heap & bps space = %d (%X), bps = %.2f, heap = %.2f\n",
        .text
/   178	          total, total, bpspercent, heappercent);
     pushl   -40(%ebp)
       pushl   -44(%ebp)
     pushl   -32(%ebp)
       pushl   -36(%ebp)
	pushl	-8(%ebp)
	pushl	-8(%ebp)
	pushl	$.L74
	call	printf
	addl	$28,%esp
/   179	
/   180	  setupbps();
	call	setupbps
/   181	  getheap(heapsize);
	pushl	-16(%ebp)
	call	getheap
	popl	%ecx
/   182	
/   183	  printf("bpssize = %d (%X), heapsize = %d (%X)\nTotal image size = %d (%X)\n",
        .text
/   184	          bpssize, bpssize,
/   185	          heapsize, heapsize,
/   186	          (int) sbrk(0), (int) sbrk(0));
	pushl	$0
	call	sbrk
	popl	%ecx
	pushl	%eax
	pushl	$0
	call	sbrk
	popl	%ecx
	pushl	%eax
	pushl	-16(%ebp)
	pushl	-16(%ebp)
	pushl	-12(%ebp)
	pushl	-12(%ebp)
	pushl	$.L77
	call	printf
	addl	$28,%esp
/   187	
/   188	  alreadysetupbpsandheap = 1;
	movl	$1,alreadysetupbpsandheap
/   189	}
.L35:
	leave
	ret
.L37:
	pushl	%ebp
	movl	%esp,%ebp
	subl	$64,%esp
	jmp	.L36
/FUNCEND
        .data
        .text
	.globl	setupbps
setupbps:
	jmp	.L80
.L79:
/   198	  NEXTBPS  =  ((int)bps + 3) & ~3;		/* Up to a multiple of 4. */
	movl	$bps+3,%eax
	andl	$-4,%eax
	movl	%eax,NEXTBPS
/   199	  BPSLOWERBOUND = NEXTBPS;
	movl	NEXTBPS,%eax
	movl	%eax,BPSLOWERBOUND
/   200	  LASTBPS  =  ((int)bps + BPSSIZE) & ~3;	/* Down to a multiple of 4. */
	movl	$bps+1500000,%eax
	andl	$-4,%eax
	movl	%eax,LASTBPS
/   201	}  
.L78:
	leave
	ret
.L80:
	pushl	%ebp
	movl	%esp,%ebp
	jmp	.L79
/FUNCEND
        .data
        .text
	.globl	allocatemorebps
allocatemorebps:
	jmp	.L84
.L83:
/   210	  int current_size_in_bytes;
/   211	  int old_NEXTBPS = NEXTBPS;
	movl	NEXTBPS,%eax
	movl	%eax,-8(%ebp)
/   212	  
/   213	  current_size_in_bytes = sbrk(0);
	pushl	$0
	call	sbrk
	popl	%ecx
	movl	%eax,-4(%ebp)
/   214	
/   215	  if ((current_size_in_bytes + EXTRABPSSIZE) >= max_image_size)
	movl	-4(%ebp),%eax
	leal	100000(%eax),%eax
	cmpl	max_image_size,%eax
	jl	.L85
/   216	    return(0);
	movl	$0,%eax
	jmp	.L82
/   217	
/   218	  if (((int)sbrk(0)) % 2)      /* force to even word boundary*/
.L85:
	pushl	$0
	call	sbrk
	popl	%ecx
	movl	$2,%ecx
	cltd
	idivl	%ecx
	testl	%edx,%edx
	je	.L86
/   219	     NEXTBPS = (int)sbrk(1);
	pushl	$1
	call	sbrk
	popl	%ecx
	movl	%eax,NEXTBPS
/   220	 
/   221	  NEXTBPS = (int)sbrk(EXTRABPSSIZE);   /* allocate extra BPS */
.L86:
	pushl	$100000
	call	sbrk
	popl	%ecx
	movl	%eax,NEXTBPS
/   222	  if (NEXTBPS == -1) {
       cmpl	$-1,NEXTBPS
	jne	.L87
/   223	    NEXTBPS = old_NEXTBPS;
	movl	-8(%ebp),%eax
	movl	%eax,NEXTBPS
/   224	    return(0);
	movl	$0,%eax
	jmp	.L82
/   225	  }
/   226	  LASTBPS = NEXTBPS + EXTRABPSSIZE;
.L87:
	movl	NEXTBPS,%eax
	leal	100000(%eax),%eax
	movl	%eax,LASTBPS
/   227	
/   228	  return(EXTRABPSSIZE);   /* This will be a paramter later */
	movl	$100000,%eax
	jmp	.L82
/   229	}
.L82:
	leave
	ret
.L84:
	pushl	%ebp
	movl	%esp,%ebp
	subl	$8,%esp
	jmp	.L83
/FUNCEND
        .data
        .text
	.globl	getheap
getheap:
	jmp	.L90
.L89:
/   237	
/   245	#else
/   246	
/   247	  HEAPLOWERBOUND        = (int)sbrk(2 * heapsize);  /* allocate first heap */;
	movl	8(%ebp),%eax
	leal	(%eax,%eax),%eax
	pushl	%eax
	call	sbrk
	popl	%ecx
	movl	%eax,HEAPLOWERBOUND
/   248	#endif
/   249	  if (HEAPLOWERBOUND == -1) {
       cmpl	$-1,HEAPLOWERBOUND
	jne	.L91
/   250	    perror("GETHEAP");
        .text
	pushl	$.L93
	call	perror
	popl	%ecx
/   251	    exit(-1);
	pushl	$-1
	call	exit
	popl	%ecx
/   252	  }
/   253	  HEAPUPPERBOUND        = HEAPLOWERBOUND + heapsize;
.L91:
	movl	HEAPLOWERBOUND,%eax
	addl	8(%ebp),%eax
	movl	%eax,HEAPUPPERBOUND
/   254	  HEAPLAST              = HEAPLOWERBOUND;
	movl	HEAPLOWERBOUND,%eax
	movl	%eax,HEAPLAST
/   255	  HEAPTRAPBOUND         = HEAPUPPERBOUND -120;
	movl	HEAPUPPERBOUND,%eax
	subl	$120,%eax
	movl	%eax,HEAPTRAPBOUND
/   256	
/   263	#endif
/   264	
/   265	#if (NUMBEROFHEAPS == 2)
/   266	
/   267	  OLDHEAPLOWERBOUND	= HEAPUPPERBOUND;
	movl	HEAPUPPERBOUND,%eax
	movl	%eax,OLDHEAPLOWERBOUND
/   268	  OLDHEAPUPPERBOUND     = OLDHEAPLOWERBOUND + heapsize;
	movl	OLDHEAPLOWERBOUND,%eax
	addl	8(%ebp),%eax
	movl	%eax,OLDHEAPUPPERBOUND
/   269	  OLDHEAPLAST           = OLDHEAPLOWERBOUND;
	movl	OLDHEAPLOWERBOUND,%eax
	movl	%eax,OLDHEAPLAST
/   270	  OLDHEAPTRAPBOUND      = OLDHEAPUPPERBOUND;
	movl	OLDHEAPUPPERBOUND,%eax
	movl	%eax,OLDHEAPTRAPBOUND
/   271	#endif
/   272	  oldbreakvalue = (int)sbrk(0);
	pushl	$0
	call	sbrk
	popl	%ecx
	movl	%eax,oldbreakvalue
/   273	}
.L88:
	leave
	ret
.L90:
	pushl	%ebp
	movl	%esp,%ebp
	jmp	.L89
/FUNCEND
        .data
        .text
	.globl	alterheapsize
alterheapsize:
	jmp	.L98
.L97:
/   280	/*
/   281	  alters the size of the heap by the specified increment.  Returns
/   282	  the increment if successful, otherwise returns 0.  May fail if
/   283	  the sbrk is unsuccessful or if the user tries to cut the heap back
/   284	  to nothing or the current break value does not match the old value.
/   285	  The latter case occurs when a malloc or sbrk has allocated space for
/   286	  some other software, in which case we cannot allocate any more space
/   287	  contiguously.
/   288	
/   289	  Modifies both the heap and gcarray size.
/   290	  NOTE: a garbage collection should probably be performed before this
/   291		routine is called.
/   292	  NOTE: only implemented for the one heap version on the 68000.
/   293	*/
/   294	
/   295	  int heapsize;
/   296	  int current_size_in_bytes;
/   297	  
/   334	#else
/   335	  /* assumes the current heap is the 'lower' one */
/   336	  int newbreakvalue;
/   337	 
/   338	  if ((int) sbrk(0) != oldbreakvalue)  /* Non contiguous memory */
	pushl	$0
	call	sbrk
	popl	%ecx
	cmpl	oldbreakvalue,%eax
	je	.L99
/   339	      return(0);
	movl	$0,%eax
	jmp	.L96
/   340	 
/   341	  current_size_in_bytes = sbrk(0);
.L99:
	pushl	$0
	call	sbrk
	popl	%ecx
	movl	%eax,-8(%ebp)
/   342	 
/   343	  if ((current_size_in_bytes + 2* increment) >= max_image_size)
	movl	8(%ebp),%eax
	leal	(%eax,%eax),%eax
	movl	-8(%ebp),%edx
	addl	%eax,%edx
	cmpl	max_image_size,%edx
	jl	.L100
/   344	    return(-1);
	movl	$-1,%eax
	jmp	.L96
/   345	 
/   346	  if ((int)sbrk(2 * increment) == -1)       /* the sbrk failed. */
.L100:
	movl	8(%ebp),%eax
	leal	(%eax,%eax),%eax
	pushl	%eax
	call	sbrk
	popl	%ecx
	cmpl	$-1,%eax
	jne	.L101
/   347	     return(-2);
	movl	$-2,%eax
	jmp	.L96
/   348	 
/   349	  newbreakvalue = (int) sbrk(0);
.L101:
	pushl	$0
	call	sbrk
	popl	%ecx
	movl	%eax,-12(%ebp)
/   350	  increment= (increment / 4) * 4;
	movl	8(%ebp),%eax
	movl	$4,%ecx
	cltd
	idivl	%ecx
	leal	(,%eax,4),%eax
	movl	%eax,8(%ebp)
/   351	 
/   352	  HEAPUPPERBOUND	= HEAPUPPERBOUND + increment;
	movl	8(%ebp),%eax
	addl	%eax,HEAPUPPERBOUND
/   353	  HEAPTRAPBOUND 	= HEAPUPPERBOUND - 120 ;
	movl	HEAPUPPERBOUND,%eax
	subl	$120,%eax
	movl	%eax,HEAPTRAPBOUND
/   354	  OLDHEAPLOWERBOUND     = OLDHEAPLOWERBOUND + increment;
	movl	8(%ebp),%eax
	addl	%eax,OLDHEAPLOWERBOUND
/   355	  OLDHEAPUPPERBOUND     = OLDHEAPUPPERBOUND + 2* increment;
	movl	8(%ebp),%eax
	leal	(%eax,%eax),%eax
	addl	%eax,OLDHEAPUPPERBOUND
/   356	  OLDHEAPLAST           = OLDHEAPLOWERBOUND;
	movl	OLDHEAPLOWERBOUND,%eax
	movl	%eax,OLDHEAPLAST
/   357	  OLDHEAPTRAPBOUND      = OLDHEAPUPPERBOUND -120;
	movl	OLDHEAPUPPERBOUND,%eax
	subl	$120,%eax
	movl	%eax,OLDHEAPTRAPBOUND
/   358	
/   359	 
/   360	  oldbreakvalue = newbreakvalue;
	movl	-12(%ebp),%eax
	movl	%eax,oldbreakvalue
/   361	  return(increment);
	movl	8(%ebp),%eax
	jmp	.L96
/   362	#endif
/   363	
/   364	}
.L96:
	leave
	ret
.L98:
	pushl	%ebp
	movl	%esp,%ebp
	subl	$12,%esp
	jmp	.L97
/FUNCEND
        .data
.L43:

        .byte    0x00
.L50:

        .byte    0x25,0x78,0x00
.L52:

        .byte    0x25,0x64,0x00
.L57:

        .byte    0x25,0x78,0x00
.L59:

        .byte    0x25,0x64,0x00
.L69:

        .byte    0x53,0x69,0x7a,0x65,0x20,0x72,0x65,0x71,0x75,0x65
        .byte    0x73,0x74,0x65,0x64,0x20,0x77,0x69,0x6c,0x6c,0x20
        .byte    0x72,0x65,0x73,0x75,0x6c,0x74,0x20,0x69,0x6e,0x20
        .byte    0x70,0x6f,0x69,0x6e,0x74,0x65,0x72,0x20,0x76,0x61
        .byte    0x6c,0x75,0x65,0x73,0x20,0x6c,0x61,0x72,0x67,0x65
        .byte    0x72,0x20,0x74,0x68,0x61,0x6e,0x0a,0x00
.L70:

        .byte    0x20,0x50,0x53,0x4c,0x20,0x69,0x74,0x65,0x6d,0x73
        .byte    0x20,0x63,0x61,0x6e,0x20,0x68,0x61,0x6e,0x64,0x6c
        .byte    0x65,0x2e,0x20,0x57,0x69,0x6c,0x6c,0x20,0x61,0x6c
        .byte    0x6c,0x6f,0x63,0x61,0x74,0x65,0x20,0x6d,0x61,0x78
        .byte    0x69,0x6d,0x75,0x6d,0x20,0x73,0x69,0x7a,0x65,0x20
        .byte    0x69,0x6e,0x73,0x74,0x65,0x61,0x64,0x2e,0x0a,0x0a
        .byte    0x00
.L73:

        .byte    0x53,0x65,0x74,0x74,0x69,0x6e,0x67,0x20,0x68,0x65
        .byte    0x61,0x70,0x20,0x6c,0x69,0x6d,0x69,0x74,0x20,0x61
        .byte    0x73,0x20,0x66,0x6f,0x6c,0x6c,0x6f,0x77,0x73,0x3a
        .byte    0x0a,0x00
.L74:

        .byte    0x54,0x6f,0x74,0x61,0x6c,0x20,0x68,0x65,0x61,0x70
        .byte    0x20,0x26,0x20,0x62,0x70,0x73,0x20,0x73,0x70,0x61
        .byte    0x63,0x65,0x20,0x3d,0x20,0x25,0x64,0x20,0x28,0x25
        .byte    0x58,0x29,0x2c,0x20,0x62,0x70,0x73,0x20,0x3d,0x20
        .byte    0x25,0x2e,0x32,0x66,0x2c,0x20,0x68,0x65,0x61,0x70
        .byte    0x20,0x3d,0x20,0x25,0x2e,0x32,0x66,0x0a,0x00
.L77:

        .byte    0x62,0x70,0x73,0x73,0x69,0x7a,0x65,0x20,0x3d,0x20
        .byte    0x25,0x64,0x20,0x28,0x25,0x58,0x29,0x2c,0x20,0x68
        .byte    0x65,0x61,0x70,0x73,0x69,0x7a,0x65,0x20,0x3d,0x20
        .byte    0x25,0x64,0x20,0x28,0x25,0x58,0x29,0x0a,0x54,0x6f
        .byte    0x74,0x61,0x6c,0x20,0x69,0x6d,0x61,0x67,0x65,0x20
        .byte    0x73,0x69,0x7a,0x65,0x20,0x3d,0x20,0x25,0x64,0x20
        .byte    0x28,0x25,0x58,0x29,0x0a,0x00
.L93:

        .byte    0x47,0x45,0x54,0x48,0x45,0x41,0x50,0x00
