%                               TEST 3
% Test the generic help system interface in h-generic.red. For special
% interfaces, you might want to replace h-generic.red with your own.
% This particular test is specific to PSL.

% To run, you need the results of p-test2.red (test.hlp and test.idx).

%   reduce
%   in "p-test3.red"$
%   bye;

% The system should print the basic help on help message. After a
% syntax error, you should answer Y to continue and watch an explanation.

% The system requires the files:
%   p-rfast.red                          PSL hack for fast arith.
%   p-sysdep.red                         PSL system dependent functions.
%   test.hlp                             From p-test2.red
%   test.idx                             From p-test2.red
%   h-format.red                         Formatted output.
%   h-generic.red                        Generic help interface.
%   h-help.red                           Basic help system.
%   h-seqio.red                          Simulated random access I/O
%   h-sysdep.red                         PSL specific functions.

symbolic;

on comp;

in "p-rfast.red"$
in "h-format.red"$
in "h-generic.red"$
in "h-help.red"$
in "h-seqio.red"$
in "p-sysdep.red"$

helpinit("test.hlp", "test.idx");


help help;
next;
previous;
related;

<< prin2t "******************************************************";
   prin2t "* Please answer Y to continue test after this error! *";
   prin2t "******************************************************";
   nil >>;
34.4.5;

help;

end;




%
